#ifndef _dimacs_h_INCLUDED
#define _dimacs_h_INCLUDED

/*------------------------------------------------------------------------*/

#include <stdlib.h>

/*------------------------------------------------------------------------*/

typedef struct Dimacs Dimacs;
typedef struct DimacsMem DimacsMem;
typedef void *(*DimacsNew) (void *mgr, size_t bytes);
typedef void (*DimacsDelete) (void *mgr, void *ptr, size_t bytes);

/*------------------------------------------------------------------------*/

struct DimacsMem
{
  void *mgr;
  DimacsNew new;
  DimacsDelete delete;
  size_t *bytes_ptr, *max_bytes_ptr;
};

/*------------------------------------------------------------------------*/

const char *DIMACS_id (void);
Dimacs *DIMACS_new (const char *, DimacsMem *);
void DIMACS_delete (Dimacs *);
const int *DIMACS_read (Dimacs *);
const char *DIMACS_error (Dimacs *);
int DIMACS_specified_max_variable (Dimacs *);
int DIMACS_specified_num_clauses (Dimacs *);

/*------------------------------------------------------------------------*/

#endif
